
using System;
using System.Runtime.InteropServices;

class repcoder32
{
 [DllImport("repcoder.dll")]
 public static extern int repc_init();

 [DllImport("repcoder.dll")]
 public static extern void repc_exit();

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_open_report(IntPtr hWnd, int bModal, string FormName, int RecordSeqNr, int nParams, int[] pParamsNumbers, string[] pParamsValues, int bParamsUpdate, int bRecNavigate, int bDesignMode, int bAllowDesign, int bAllowUpdate);

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_open_report2(IntPtr hWnd, int bModal, string FormName, int RecordSeqNr, string Parameters, int bParamsUpdate, int bRecNavigate, int bDesignMode, int bAllowDesign, int bAllowUpdate);
 
 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_call_report(IntPtr hWnd, int bModal, string FormName, int bDesignMode);

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_call_report_param(IntPtr hWnd, int bModal, string FormName, int bDesignMode, int nParams, int[] pParamsNumbers, string[] pParamsValues, int bParamsUpdate);

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_call_report_param2(IntPtr hWnd, int bModal, string FormName, int bDesignMode, string Parameters, int bParamsUpdate);
 
 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern void repc_explorer(IntPtr hWnd, int bModal, string Dir, int bDesign, int bResultOnly);

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern void repc_explorer_param(IntPtr hWnd, int bModal, string Dir, int bDesign, int bResultOnly, int nParams, int[] pParamsNumbers, string[] pParamsValues, int bParamsUpdate);

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_get_report_desc_len(string FormName);

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_get_report_desc(string FormName, char[] buf, int len);

 [DllImport("repcoder.dll")]
 public static extern int repc_get_open_count();

 [DllImport("repcoder.dll")]
 public static extern int repc_can_exit();

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern void repc_set_user(string User);

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern void repc_set_pass(string Pass);

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern void repc_set_role(string Role);

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern void repc_set_charset(string CharSet);

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern void repc_set_logo(string szLogo, int bReplace);

 [DllImport("repcoder.dll")]
 public static extern int repc_get_demo();

 [DllImport("repcoder.dll")]
 public static extern int repc_set_demo(int bDemo);

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern void repc_set_bde_netdir(string dir);

 [DllImport("repcoder.dll")]
 public static extern void repc_set_fbclient_thread_safe(int bSafe);

 [DllImport("repcoder.dll")]
 public static extern void repc_set_ibclient_thread_safe(int bSafe);
 
 [DllImport("repcoder.dll")]
 public static extern void repc_set_dialog_fonts(int Type);

 [DllImport("repcoder.dll")]
 public static extern void repc_set_user_interface_lang(int Lang);

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_create_result(string FormName, string ResultName, string ResultDesc,
 char[] ErrorBuf, int ErrorBufLen);
 
 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_create_result_param(string FormName, string ResultName, string ResultDesc,
 int nParams, int[] pParamsNumbers, string[] pParamsValues, char[] ErrorBuf, int ErrorBufLen);
 
 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_admin_setup(int bInterBase, string ConnString, 
 string User, string Pass, string ProjectName, string DbName,
 string DbLogin, string DbPass, string DbRole, int bVerify, int bShowErrorMess); 
 
 [DllImport("repcoder.dll")]
 public static extern int rcalc_alloc_handle();

 [DllImport("repcoder.dll")]
 public static extern int rcalc_copy_handle(int calc_handle);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_free_handle(int calc_handle);
 
 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_state(int calc_handle);
 
 [DllImport("repcoder.dll")]
 public static extern int rcalc_is_valid(int calc_handle);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_is_compiled(int calc_handle);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_is_executed(int calc_handle);

 [DllImport("repcoder.dll")]
 public static extern void rcalc_set_status_window(int calc_handle, IntPtr hStatWnd);
 
 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_compile(int calc_handle, string Source);

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_compile_file(int calc_handle, string Source, int Format);
 
 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_execute(int calc_handle, int nInput, string[] pInputValues);

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_execute2(int calc_handle, string InputValues, string Separator);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_input_count(int calc_handle);
 
 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_output_count(int calc_handle);
 
 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_compiled_text_len(int calc_handle, int bCRLF);
 
 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_copy_compiled_text(int calc_handle, int bCRLF, char[] buf, int len);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_isnull_input(int calc_handle, int number);
 
 [DllImport("repcoder.dll")]
 public static extern int rcalc_isnull_output(int calc_handle, int number);
  
 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_input_type(int calc_handle, int number);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_output_type(int calc_handle, int number);
 
 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_output_type_textlen(int calc_handle, int number);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_input_type_numscale(int calc_handle, int number);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_output_type_numscale(int calc_handle, int number);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_input_type_name_len(int calc_handle, int number);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_output_type_name_len(int calc_handle, int number);

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_copy_input_type_name(int calc_handle, int number, char[] buf, int len);
 
 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_copy_output_type_name(int calc_handle, int number, char[] buf, int len);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_input_name_len(int calc_handle, int number);
 
 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_output_name_len(int calc_handle, int number);

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_copy_input_name(int calc_handle, int number, char[] buf, int len);
 
 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_copy_output_name(int calc_handle, int number, char[] buf, int len);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_input_string_len(int calc_handle, int number);
 
 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_output_string_len(int calc_handle, int number);

 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_copy_input_string(int calc_handle, int number, char[] buf, int len);
 
 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_copy_output_string(int calc_handle, int number, char[] buf, int len);

 [DllImport("repcoder.dll")]
 public static extern double rcalc_get_input_double(int calc_handle, int number);
 
 [DllImport("repcoder.dll")]
 public static extern double rcalc_get_output_double(int calc_handle, int number);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_input_int(int calc_handle, int number);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_output_int(int calc_handle, int number);

 [DllImport("repcoder.dll")]
 public static extern long rcalc_get_input_numeric(int calc_handle, int number);
 
 [DllImport("repcoder.dll")]
 public static extern long rcalc_get_output_numeric(int calc_handle, int number);

 [DllImport("repcoder.dll")]
 public static extern long rcalc_get_input_time(int calc_handle, int number);

 [DllImport("repcoder.dll")]
 public static extern long rcalc_get_output_time(int calc_handle, int number);
 
 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_error_text_len();
 
 [DllImport("repcoder.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_copy_error_text(char[] buf, int len);
 
 [DllImport("repcoder.dll")]
 public static extern void rcalc_show_error(IntPtr hWnd);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_year(long value);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_month(long value);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_day(long value);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_hour(long value);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_minute(long value);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_second(long value);

 [DllImport("repcoder.dll")]
 public static extern int rcalc_get_millisec(long value);
}
//---------------------------------------

class repcoder64
{
 [DllImport("repcoder64.dll")]
 public static extern int repc_init();

 [DllImport("repcoder64.dll")]
 public static extern void repc_exit();

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_open_report(IntPtr hWnd, int bModal, string FormName, int RecordSeqNr, int nParams, int[] pParamsNumbers, string[] pParamsValues, int bParamsUpdate, int bRecNavigate, int bDesignMode, int bAllowDesign, int bAllowUpdate);

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_open_report2(IntPtr hWnd, int bModal, string FormName, int RecordSeqNr, string Parameters, int bParamsUpdate, int bRecNavigate, int bDesignMode, int bAllowDesign, int bAllowUpdate);
 
 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_call_report(IntPtr hWnd, int bModal, string FormName, int bDesignMode);

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_call_report_param(IntPtr hWnd, int bModal, string FormName, int bDesignMode, int nParams, int[] pParamsNumbers, string[] pParamsValues, int bParamsUpdate);

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_call_report_param2(IntPtr hWnd, int bModal, string FormName, int bDesignMode, string Parameters, int bParamsUpdate);
 
 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern void repc_explorer(IntPtr hWnd, int bModal, string Dir, int bDesign, int bResultOnly);

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern void repc_explorer_param(IntPtr hWnd, int bModal, string Dir, int bDesign, int bResultOnly, int nParams, int[] pParamsNumbers, string[] pParamsValues, int bParamsUpdate);

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_get_report_desc_len(string FormName);

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_get_report_desc(string FormName, char[] buf, int len);

 [DllImport("repcoder64.dll")]
 public static extern int repc_get_open_count();

 [DllImport("repcoder64.dll")]
 public static extern int repc_can_exit();

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern void repc_set_user(string User);

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern void repc_set_pass(string Pass);

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern void repc_set_role(string Role);

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern void repc_set_charset(string CharSet);

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern void repc_set_logo(string szLogo, int bReplace);

 [DllImport("repcoder64.dll")]
 public static extern int repc_get_demo();

 [DllImport("repcoder64.dll")]
 public static extern int repc_set_demo(int bDemo);

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern void repc_set_bde_netdir(string dir);

 [DllImport("repcoder64.dll")]
 public static extern void repc_set_fbclient_thread_safe(int bSafe);

 [DllImport("repcoder64.dll")]
 public static extern void repc_set_ibclient_thread_safe(int bSafe);
 
 [DllImport("repcoder64.dll")]
 public static extern void repc_set_dialog_fonts(int Type);
 
 [DllImport("repcoder64.dll")]
 public static extern void repc_set_user_interface_lang(int Lang);

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_create_result(string FormName, string ResultName, string ResultDesc,
 char[] ErrorBuf, int ErrorBufLen);
 
 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_create_result_param(string FormName, string ResultName, string ResultDesc,
 int nParams, int[] pParamsNumbers, string[] pParamsValues, char[] ErrorBuf, int ErrorBufLen);
 
 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int repc_admin_setup(int bInterBase, string ConnString, 
 string User, string Pass, string ProjectName, string DbName,
 string DbLogin, string DbPass, string DbRole, int bVerify, int bShowErrorMess);
 
 [DllImport("repcoder64.dll")]
 public static extern int rcalc_alloc_handle();

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_copy_handle(int calc_handle);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_free_handle(int calc_handle);
 
 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_state(int calc_handle);
 
 [DllImport("repcoder64.dll")]
 public static extern int rcalc_is_valid(int calc_handle);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_is_compiled(int calc_handle);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_is_executed(int calc_handle);
 
 [DllImport("repcoder64.dll")]
 public static extern void rcalc_set_status_window(int calc_handle, IntPtr hStatWnd);
  
 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_compile(int calc_handle, string Source);

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_compile_file(int calc_handle, string Source, int Format);
 
 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_execute(int calc_handle, int nInput, string[] pInputValues);

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_execute2(int calc_handle, string InputValues, string Separator);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_input_count(int calc_handle);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_output_count(int calc_handle);
 
 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_compiled_text_len(int calc_handle, int bCRLF);
 
 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_copy_compiled_text(int calc_handle, int bCRLF, char[] buf, int len);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_isnull_input(int calc_handle, int number);
 
 [DllImport("repcoder64.dll")]
 public static extern int rcalc_isnull_output(int calc_handle, int number);
 
 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_input_type(int calc_handle, int number);
 
 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_output_type(int calc_handle, int number); 

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_output_type_textlen(int calc_handle, int number);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_input_type_numscale(int calc_handle, int number);
 
 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_output_type_numscale(int calc_handle, int number);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_input_type_name_len(int calc_handle, int number);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_output_type_name_len(int calc_handle, int number);

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_copy_input_type_name(int calc_handle, int number, char[] buf, int len);
 
 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_copy_output_type_name(int calc_handle, int number, char[] buf, int len);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_input_name_len(int calc_handle, int number);
 
 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_output_name_len(int calc_handle, int number);

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_copy_input_name(int calc_handle, int number, char[] buf, int len);  
 
 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_copy_output_name(int calc_handle, int number, char[] buf, int len);  

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_input_string_len(int calc_handle, int number);
 
 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_output_string_len(int calc_handle, int number);

 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_copy_input_string(int calc_handle, int number, char[] buf, int len);
 
 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_copy_output_string(int calc_handle, int number, char[] buf, int len);

 [DllImport("repcoder64.dll")]
 public static extern double rcalc_get_input_double(int calc_handle, int number);

 [DllImport("repcoder64.dll")]
 public static extern double rcalc_get_output_double(int calc_handle, int number);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_input_int(int calc_handle, int number);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_output_int(int calc_handle, int number);

 [DllImport("repcoder64.dll")]
 public static extern long rcalc_get_input_numeric(int calc_handle, int number);

 [DllImport("repcoder64.dll")]
 public static extern long rcalc_get_output_numeric(int calc_handle, int number);

 [DllImport("repcoder64.dll")]
 public static extern long rcalc_get_input_time(int calc_handle, int number);

 [DllImport("repcoder64.dll")]
 public static extern long rcalc_get_output_time(int calc_handle, int number);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_error_text_len();
 
 [DllImport("repcoder64.dll", CharSet = CharSet.Unicode)]
 public static extern int rcalc_copy_error_text(char[] buf, int len);

 [DllImport("repcoder64.dll")]
 public static extern void rcalc_show_error(IntPtr hWnd);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_year(long value);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_month(long value);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_day(long value);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_hour(long value);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_minute(long value);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_second(long value);

 [DllImport("repcoder64.dll")]
 public static extern int rcalc_get_millisec(long value); 
}
//---------------------------------------

class Repcoder
{
 public static bool is64()
   {
    return (IntPtr.Size == 8)? true: false;
   }
 
 public static bool init()
   {
    int ok = 0;
    if( is64() ) ok = repcoder64.repc_init();
    else ok = repcoder32.repc_init();
    
    return (ok == 1)? true: false;
   }

 public static void exit()
   {
    if( is64() ) repcoder64.repc_exit();
    else repcoder32.repc_exit();   
   }

 public static bool open_report(IntPtr hWnd, bool bModal, string FormName, int RecordSeqNr,
 int[] pParamsNumbers, string[] pParamsValues, bool bParamsUpdate, bool bRecNavigate,
 bool bDesignMode, bool bAllowDesign, bool bAllowUpdate)
   {
    int modal = (bModal == true)? 1: 0;
    int paramsupdate = (bParamsUpdate == true)? 1: 0;
    int recnavigate = (bRecNavigate == true)? 1: 0;
    int designmode = (bDesignMode == true)? 1: 0;
    int allowdesign = (bAllowDesign == true)? 1: 0;
    int allowupdate = (bAllowUpdate == true)? 1: 0;
    
    int nParams = pParamsNumbers.Length;
    if( pParamsValues.Length < nParams ) nParams = pParamsValues.Length;
	 
	int ok = 0;
    if( is64() )
      {
       ok = repcoder64.repc_open_report(hWnd, modal, FormName, RecordSeqNr,
       nParams, pParamsNumbers, pParamsValues, paramsupdate, recnavigate, designmode, allowdesign, allowupdate);
      }
    else
      {
       ok = repcoder32.repc_open_report(hWnd, modal, FormName, RecordSeqNr,
       nParams, pParamsNumbers, pParamsValues, paramsupdate, recnavigate, designmode, allowdesign, allowupdate);      
      }      

    return (ok == 1)? true: false;
   }

 public static bool open_report2(IntPtr hWnd, bool bModal, string FormName, int RecordSeqNr,
 string Parameters, bool bParamsUpdate, bool bRecNavigate,
 bool bDesignMode, bool bAllowDesign, bool bAllowUpdate)
   {
    int modal = (bModal == true)? 1: 0;
    int paramsupdate = (bParamsUpdate == true)? 1: 0;
    int recnavigate = (bRecNavigate == true)? 1: 0;
    int designmode = (bDesignMode == true)? 1: 0;
    int allowdesign = (bAllowDesign == true)? 1: 0;
    int allowupdate = (bAllowUpdate == true)? 1: 0;
	 
	int ok = 0;
    if( is64() )
      {
       ok = repcoder64.repc_open_report2(hWnd, modal, FormName, RecordSeqNr,
       Parameters, paramsupdate, recnavigate, designmode, allowdesign, allowupdate);
      }
    else
      {
       ok = repcoder32.repc_open_report2(hWnd, modal, FormName, RecordSeqNr,
       Parameters, paramsupdate, recnavigate, designmode, allowdesign, allowupdate);      
      }      

    return (ok == 1)? true: false;
   }
   
 public static bool call_report(IntPtr hWnd, bool bModal, string FormName, bool bDesignMode)
   {
    int modal = (bModal == true)? 1: 0;
    int designmode = (bDesignMode == true)? 1: 0;
    
	int ok = 0;
    if( is64() )
      {
       ok = repcoder64.repc_call_report(hWnd, modal, FormName, designmode);
      }
    else
      {
       ok = repcoder32.repc_call_report(hWnd, modal, FormName, designmode);
      }      
      
    return (ok == 1)? true: false;
   }

 public static bool call_report_param(IntPtr hWnd, bool bModal, string FormName, bool bDesignMode,
 int[] pParamsNumbers, string[] pParamsValues, bool bParamsUpdate)
   {
    int modal = (bModal == true)? 1: 0;
    int paramsupdate = (bParamsUpdate == true)? 1: 0;
    int designmode = (bDesignMode == true)? 1: 0;
   
    int nParams = pParamsNumbers.Length;
    if( pParamsValues.Length < nParams ) nParams = pParamsValues.Length;
   
    int ok = 0;
    if( is64() )
      {       
       ok = repcoder64.repc_call_report_param(hWnd, modal, FormName, designmode,
       nParams, pParamsNumbers, pParamsValues, paramsupdate);       
      }
    else
      {
       ok = repcoder32.repc_call_report_param(hWnd, modal, FormName, designmode,
       nParams, pParamsNumbers, pParamsValues, paramsupdate);              
      }      
    
    return (ok == 1)? true: false;
   }   

 public static bool call_report_param2(IntPtr hWnd, bool bModal, string FormName, bool bDesignMode,
 string Parameters, bool bParamsUpdate)
   {
    int modal = (bModal == true)? 1: 0;
    int paramsupdate = (bParamsUpdate == true)? 1: 0;
    int designmode = (bDesignMode == true)? 1: 0;
   
    int ok = 0;
    if( is64() )
      {       
       ok = repcoder64.repc_call_report_param2(hWnd, modal, FormName, designmode,
       Parameters, paramsupdate);       
      }
    else
      {
       ok = repcoder32.repc_call_report_param2(hWnd, modal, FormName, designmode,
       Parameters, paramsupdate);              
      }      
    
    return (ok == 1)? true: false;
   }   
   
 public static void explorer(IntPtr hWnd, bool bModal, string Dir, bool bDesign, bool bResultOnly)
   {
    int modal = (bModal == true)? 1: 0;
    int design = (bDesign == true)? 1: 0;
    int resultonly = (bResultOnly == true)? 1: 0;
   
    if( is64() ) repcoder64.repc_explorer(hWnd, modal, Dir, design, resultonly);
    else repcoder32.repc_explorer(hWnd, modal, Dir, design, resultonly);
   }

 public static void explorer_param(IntPtr hWnd, bool bModal, string Dir, bool bDesign, bool bResultOnly,
 int[] pParamsNumbers, string[] pParamsValues, bool bParamsUpdate)
   {
    int modal = (bModal == true)? 1: 0;
    int design = (bDesign == true)? 1: 0;
    int resultonly = (bResultOnly == true)? 1: 0;
    int paramsupdate = (bParamsUpdate == true)? 1: 0;

    int nParams = pParamsNumbers.Length;
    if( pParamsValues.Length < nParams ) nParams = pParamsValues.Length;
    
    if( is64() ) 
      {
       repcoder64.repc_explorer_param(hWnd, modal, Dir, design, resultonly,
       nParams, pParamsNumbers, pParamsValues, paramsupdate);
      }
    else
      {
       repcoder32.repc_explorer_param(hWnd, modal, Dir, design, resultonly,
       nParams, pParamsNumbers, pParamsValues, paramsupdate);      
      }
   }

 public static string get_report_desc(string FormName)
   {
    int n = 0;
    if( is64() ) n = repcoder64.repc_get_report_desc_len(FormName);
    else n = repcoder32.repc_get_report_desc_len(FormName);

    string s = "";
    if( n <= 0 ) return s;

    char[] buf = new char[n+1];
     
    int ok = 0;
    if( is64() ) ok = repcoder64.repc_get_report_desc(FormName, buf, n+1);
    else ok = repcoder32.repc_get_report_desc(FormName, buf, n+1);
	 
    if( ok != 0 )
      {
       for(int i=0; i<n+1; i++)
         {
          if( buf[i] == 0 ) buf[i] = ' ';
         }
       
       s = new string(buf);
       return s.Trim();
      }
    else return s;   
   }

 public static int get_open_count()
   {
    if( is64() ) return repcoder64.repc_get_open_count();
    else return repcoder32.repc_get_open_count();
   }

 public static bool can_exit()
   {
    int canexit = 0;   
    if( is64() ) canexit = repcoder64.repc_can_exit();
    else canexit = repcoder32.repc_can_exit();
     
    return (canexit == 1)? true: false;
   }	
   
 public static void set_user(string User)
   {
    if( is64() ) repcoder64.repc_set_user(User);
    else repcoder32.repc_set_user(User);    
   }

 public static void set_pass(string Pass)
   {
    if( is64() ) repcoder64.repc_set_pass(Pass);
    else repcoder32.repc_set_pass(Pass);
   }
   
 public static void set_role(string Role)
   {
    if( is64() ) repcoder64.repc_set_role(Role);
    else repcoder32.repc_set_role(Role);
   }

 public static void set_charset(string CharSet)
   {
    if( is64() ) repcoder64.repc_set_charset(CharSet);
    else repcoder32.repc_set_charset(CharSet);    
   }

 public static void set_logo(string Logo, bool bReplace)
   {
    int replace = (bReplace == true)? 1: 0;	 
    
    if( is64() ) repcoder64.repc_set_logo(Logo, replace);
    else repcoder32.repc_set_logo(Logo, replace);    
   }

 public static bool get_demo()
   {    
    int demo = 0;    
    if( is64() ) demo = repcoder64.repc_get_demo();
    else demo = repcoder32.repc_get_demo();
    
    return (demo == 1)? true: false;
   }

 public static bool set_demo(bool bDemo)
   {
    int demo = (bDemo == true)? 1: 0;

    int old_demo = 0;
    if( is64() ) old_demo = repcoder64.repc_set_demo(demo);
    else old_demo = repcoder32.repc_set_demo(demo);

    return (old_demo == 1)? true: false;
   }

 public static void set_bde_netdir(string dir)
   {
    if( is64() ) repcoder64.repc_set_bde_netdir(dir);
    else repcoder32.repc_set_bde_netdir(dir);
   }
	
 public static void set_fbclient_thread_safe(bool bSafe)
   {
    int safe = (bSafe == true)? 1: 0;    
    if( is64() ) repcoder64.repc_set_fbclient_thread_safe(safe);
    else repcoder32.repc_set_fbclient_thread_safe(safe);    
   }

 public static void set_ibclient_thread_safe(bool bSafe)
   {
    int safe = (bSafe == true)? 1: 0;    
    if( is64() ) repcoder64.repc_set_ibclient_thread_safe(safe);
    else repcoder32.repc_set_ibclient_thread_safe(safe);    
   }
   
 public static void set_dialog_fonts(int Type)
   {
    if( is64() ) repcoder64.repc_set_dialog_fonts(Type);
    else repcoder32.repc_set_dialog_fonts(Type);
   }
   
 public static void set_user_interface_lang(int Lang)
   {
    if( is64() ) repcoder64.repc_set_user_interface_lang(Lang);
    else repcoder32.repc_set_user_interface_lang(Lang);
   }
   
 public static string create_result(string FormName, string ResultName, string ResultDesc)
   {
    char[] ErrorBuf = new char[2048];
    int ErrorBufLen = 2048;
    
    int ok = 0;
    if( is64() ) ok = repcoder64.repc_create_result(FormName, ResultName, ResultDesc, ErrorBuf, ErrorBufLen);
    else ok = repcoder32.repc_create_result(FormName, ResultName, ResultDesc, ErrorBuf, ErrorBufLen);
    
    string s = "";
    if( ok == 1 ) return s;
	 
    for(int i=0; i<2048; i++)
      {
       if( ErrorBuf[i] == 0 ) ErrorBuf[i] = ' ';
      }
       
    s = new string(ErrorBuf);
    return s.Trim();    
   }  
   
 public static string create_result_param(string FormName, string ResultName, string ResultDesc,
 int[] pParamsNumbers, string[] pParamsValues)
   {
    char[] ErrorBuf = new char[2048];
    int ErrorBufLen = 2048;

    int nParams = pParamsNumbers.Length;
    if( pParamsValues.Length < nParams ) nParams = pParamsValues.Length;
    
    int ok = 0;
    if( is64() ) ok = repcoder64.repc_create_result_param(FormName, ResultName, ResultDesc, nParams, pParamsNumbers, pParamsValues, ErrorBuf, ErrorBufLen);
    else ok = repcoder32.repc_create_result_param(FormName, ResultName, ResultDesc, nParams, pParamsNumbers, pParamsValues, ErrorBuf, ErrorBufLen);
    
    string s = "";
    if( ok == 1 ) return s;
	 
    for(int i=0; i<2048; i++)
      {
       if( ErrorBuf[i] == 0 ) ErrorBuf[i] = ' ';
      }
       
    s = new string(ErrorBuf);
    return s.Trim();    
   }  
 
 public static bool admin_setup(bool bInterBase, string ConnString, string User, string Pass, string ProjectName, string DbName, string DbLogin, string DbPass, string DbRole, bool bVerify, bool bShowErrorMess)
   {
    int interbase = (bInterBase == true)? 1: 0;
    int verify = (bVerify == true)? 1: 0;
    int showerrormess = (bShowErrorMess == true)? 1: 0;
    
    int ok = 0;
    if( is64() ) ok = repcoder64.repc_admin_setup(interbase, ConnString, User, Pass, ProjectName, DbName, DbLogin, DbPass, DbRole, verify, showerrormess);
    else ok = repcoder32.repc_admin_setup(interbase, ConnString, User, Pass, ProjectName, DbName, DbLogin, DbPass, DbRole, verify, showerrormess);
    
    return (ok == 1)? true: false;
   }   
}
//---------------------------------------

class RCALC
{
int Handle;

public RCALC()
  {
   if( Repcoder.is64() ) Handle = repcoder64.rcalc_alloc_handle();
   else Handle = repcoder32.rcalc_alloc_handle();  
  }

public RCALC(RCALC rc)
  {
   if( Repcoder.is64() ) Handle = repcoder64.rcalc_copy_handle(rc.Handle);
   else Handle = repcoder32.rcalc_copy_handle(rc.Handle);
  }
  
~RCALC()
  {
   if( Handle > 0 )
     {
      if( Repcoder.is64() ) repcoder64.rcalc_free_handle(Handle);
      else Handle = repcoder32.rcalc_free_handle(Handle);      
     }
  }

public bool CopyFrom(RCALC rc)
  {
   if( Handle == rc.Handle ) return false;
   
   if( Repcoder.is64() )
     {
      if( Handle > 0 ) 
        {
         int ok = repcoder64.rcalc_free_handle(Handle);
         if( ok == 1 ) 
           {
            Handle = repcoder64.rcalc_copy_handle(rc.Handle);
            return (Handle > 0);
           }
         else return false;
        }
      else return false;
     }
   else
     {
      if( Handle > 0 ) 
        {
         int ok = repcoder32.rcalc_free_handle(Handle);
         if( ok == 1 ) 
           {
            Handle = repcoder32.rcalc_copy_handle(rc.Handle);
            return (Handle > 0);
           }
         else return false;
        }
      else return false;
     }
  }

public int GetHandle()
  {
   return Handle;
  }

public int GetState()
  {
   if( Handle <= 0 ) return 0;
   if( Repcoder.is64() ) return repcoder64.rcalc_get_state(Handle);
   else return repcoder32.rcalc_get_state(Handle);
  }
  
public bool IsValid()
  {
   if( Handle <= 0 ) return false;
   if( Repcoder.is64() ) return (repcoder64.rcalc_is_valid(Handle) == 1)? true: false;
   else return (repcoder32.rcalc_is_valid(Handle) == 1)? true: false;
  }
  
public bool IsCompiled()
  {
   if( Handle <= 0 ) return false;
   if( Repcoder.is64() ) return (repcoder64.rcalc_is_compiled(Handle) == 1)? true: false;
   else return (repcoder32.rcalc_is_compiled(Handle) == 1)? true: false;
  }
  
public bool IsExecuted()
  {
   if( Handle <= 0 ) return false;
   if( Repcoder.is64() ) return (repcoder64.rcalc_is_executed(Handle) == 1)? true: false;
   else return (repcoder32.rcalc_is_executed(Handle) == 1)? true: false;
  }
  
public void SetStatusWindow(IntPtr hStatWnd)
  {
   if( Handle <= 0 ) return;
   if( Repcoder.is64() ) repcoder64.rcalc_set_status_window(Handle, hStatWnd);
   else repcoder32.rcalc_set_status_window(Handle, hStatWnd);
  }

public bool Compile(string Source)
  {
   if( Handle <= 0 ) return false;
   
   int ok = 0;
   if( Repcoder.is64() ) ok = repcoder64.rcalc_compile(Handle, Source);
   else ok = repcoder32.rcalc_compile(Handle, Source);
   
   return (ok == 1)? true: false;
  }
  
public bool CompileFile(string FileName, int Format)
  {
   if( Handle <= 0 ) return false;
   
   int ok = 0;
   if( Repcoder.is64() ) ok = repcoder64.rcalc_compile_file(Handle, FileName, Format);
   else ok = repcoder32.rcalc_compile_file(Handle, FileName, Format);
   
   return (ok == 1)? true: false;
  }

public bool Execute(string[] InputValues)
  {
   if( Handle <= 0 ) return false;
   
   int ok = 0;
   if( Repcoder.is64() ) ok = repcoder64.rcalc_execute(Handle, InputValues.Length, InputValues);
   else ok = repcoder32.rcalc_execute(Handle, InputValues.Length, InputValues);
   
   return (ok == 1)? true: false;
  }

public bool Execute(string InputValues, string Separator)
  {
   if( Handle <= 0 ) return false;
   
   int ok = 0;
   if( Repcoder.is64() ) ok = repcoder64.rcalc_execute2(Handle, InputValues, Separator);
   else ok = repcoder32.rcalc_execute2(Handle, InputValues, Separator);
   
   return (ok == 1)? true: false;
  }

public bool Execute(string InputValues)
  {
   return Execute(InputValues, "###");
  }

public bool Execute()
  {
   return Execute("", "");
  }

public string CompiledText(bool bCRLF)
  {
   string s = "";
   if( Handle <= 0 ) return s;
   
   int bCR = (bCRLF)? 1: 0;
   
   int n = 0;
   if( Repcoder.is64() ) n = repcoder64.rcalc_get_compiled_text_len(Handle, bCR);
   else n = repcoder32.rcalc_get_compiled_text_len(Handle, bCR);
   
   if( n <= 0 ) return s;
   
   char[] buf = new char[n+1];
     
   int ok = 0;
   if( Repcoder.is64() ) ok = repcoder64.rcalc_copy_compiled_text(Handle, bCR, buf, n+1);
   else ok = repcoder32.rcalc_copy_compiled_text(Handle, bCR, buf, n+1);
	 
   if( ok != 0 )
     {
      for(int i=0; i<n+1; i++)
        {
         if( buf[i] == 0 ) buf[i] = ' ';
        }
       
      s = new string(buf);
      return s.Trim();
     }
   else return s;
  }

public int InputCount()
  {
   if( Handle <= 0 ) return 0;
   if( Repcoder.is64() ) return repcoder64.rcalc_get_input_count(Handle);
   else return repcoder32.rcalc_get_input_count(Handle);
  }

public int InputType(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;
   if( Repcoder.is64() ) return repcoder64.rcalc_get_input_type(Handle, number);
   else return repcoder32.rcalc_get_input_type(Handle, number);
  }

public int InputTypeNumericScale(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;
   if( Repcoder.is64() ) return repcoder64.rcalc_get_input_type_numscale(Handle, number);
   else return repcoder32.rcalc_get_input_type_numscale(Handle, number);
  }

public string InputTypeName(int number)
  {
   string s = "";
   if( Handle <= 0 || number <= 0 ) return s;
   
   int n = 0;
   if( Repcoder.is64() ) n = repcoder64.rcalc_get_input_type_name_len(Handle, number);
   else n = repcoder32.rcalc_get_input_type_name_len(Handle, number);

   if( n <= 0 ) return s;

   char[] buf = new char[n+1];

   int ok = 0;
   if( Repcoder.is64() ) ok = repcoder64.rcalc_copy_input_type_name(Handle, number, buf, n+1);
   else ok = repcoder32.rcalc_copy_input_type_name(Handle, number, buf, n+1);

   if( ok != 0 )
     {
      for(int i=0; i<n+1; i++)
        {
         if( buf[i] == 0 ) buf[i] = ' ';
        }
       
      s = new string(buf);
      return s.Trim();
     }
   else return s;
  }

public string InputName(int number)
  {
   string s = "";
   if( Handle <= 0 || number <= 0 ) return s;
   
   int n = 0;
   if( Repcoder.is64() ) n = repcoder64.rcalc_get_input_name_len(Handle, number);
   else n = repcoder32.rcalc_get_input_name_len(Handle, number);
   
   if( n <= 0 ) return s;
   
   char[] buf = new char[n+1];
     
   int ok = 0;
   if( Repcoder.is64() ) ok = repcoder64.rcalc_copy_input_name(Handle, number, buf, n+1);
   else ok = repcoder32.rcalc_copy_input_name(Handle, number, buf, n+1);
	 
   if( ok != 0 )
     {
      for(int i=0; i<n+1; i++)
        {
         if( buf[i] == 0 ) buf[i] = ' ';
        }
       
      s = new string(buf);
      return s.Trim();
     }
   else return s;   
  }

public bool InputIsNull(int number)
  {
   if( Handle <= 0 || number <= 0 ) return true;

   int ok = 0;
   if( Repcoder.is64() ) ok = repcoder64.rcalc_isnull_input(Handle, number);
   else ok = repcoder32.rcalc_isnull_input(Handle, number);
   
   return (ok == 1)? true: false;
  }

public string InputString(int number)
  {
   string s = "";
   if( Handle <= 0 || number <= 0 ) return s;
   
   int n = 0;
   if( Repcoder.is64() ) n = repcoder64.rcalc_get_input_string_len(Handle, number);
   else n = repcoder32.rcalc_get_input_string_len(Handle, number);
   
   if( n <= 0 ) return s;
   
   char[] buf = new char[n+1];
     
   int ok = 0;
   if( Repcoder.is64() ) ok = repcoder64.rcalc_copy_input_string(Handle, number, buf, n+1);
   else ok = repcoder32.rcalc_copy_input_string(Handle, number, buf, n+1);
	 
   if( ok != 0 )
     {
      for(int i=0; i<n+1; i++)
        {
         if( buf[i] == 0 ) buf[i] = ' ';
        }
       
      s = new string(buf);
      return s.Trim();
     }
   else return s;
  }

public double InputDouble(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;

   if( Repcoder.is64() ) return repcoder64.rcalc_get_input_double(Handle, number);
   else return repcoder32.rcalc_get_input_double(Handle, number);
  }

public int InputInt(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;

   if( Repcoder.is64() ) return repcoder64.rcalc_get_input_int(Handle, number);
   else return repcoder32.rcalc_get_input_int(Handle, number);
  }

public long InputNumeric(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;

   if( Repcoder.is64() ) return repcoder64.rcalc_get_input_numeric(Handle, number);
   else return repcoder32.rcalc_get_input_numeric(Handle, number);
  }

public long InputTime(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;

   if( Repcoder.is64() ) return repcoder64.rcalc_get_input_time(Handle, number);
   else return repcoder32.rcalc_get_input_time(Handle, number);
  }

public int OutputCount()
  {
   if( Handle <= 0 ) return 0;
   if( Repcoder.is64() ) return repcoder64.rcalc_get_output_count(Handle);
   else return repcoder32.rcalc_get_output_count(Handle);
  }
    
public int OutType(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;

   if( Repcoder.is64() ) return repcoder64.rcalc_get_output_type(Handle, number);
   else return repcoder32.rcalc_get_output_type(Handle, number);
  }

public int OutTypeTextLen(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;

   if( Repcoder.is64() ) return repcoder64.rcalc_get_output_type_textlen(Handle, number);
   else return repcoder32.rcalc_get_output_type_textlen(Handle, number);
  }

public int OutTypeNumericScale(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;

   if( Repcoder.is64() ) return repcoder64.rcalc_get_output_type_numscale(Handle, number);
   else return repcoder32.rcalc_get_output_type_numscale(Handle, number);
  }

public string OutTypeName(int number)
  {
   string s = "";
   if( Handle <= 0 || number <= 0 ) return s;
   
   int n = 0;
   if( Repcoder.is64() ) n = repcoder64.rcalc_get_output_type_name_len(Handle, number);
   else n = repcoder32.rcalc_get_output_type_name_len(Handle, number);

   if( n <= 0 ) return s;

   char[] buf = new char[n+1];

   int ok = 0;
   if( Repcoder.is64() ) ok = repcoder64.rcalc_copy_output_type_name(Handle, number, buf, n+1);
   else ok = repcoder32.rcalc_copy_output_type_name(Handle, number, buf, n+1);

   if( ok != 0 )
     {
      for(int i=0; i<n+1; i++)
        {
         if( buf[i] == 0 ) buf[i] = ' ';
        }
       
      s = new string(buf);
      return s.Trim();
     }
   else return s;
  }

public string OutName(int number)
  {
   string s = "";
   if( Handle <= 0 || number <= 0 ) return s;
   
   int n = 0;
   if( Repcoder.is64() ) n = repcoder64.rcalc_get_output_name_len(Handle, number);
   else n = repcoder32.rcalc_get_output_name_len(Handle, number);
   
   if( n <= 0 ) return s;
   
   char[] buf = new char[n+1];
     
   int ok = 0;
   if( Repcoder.is64() ) ok = repcoder64.rcalc_copy_output_name(Handle, number, buf, n+1);
   else ok = repcoder32.rcalc_copy_output_name(Handle, number, buf, n+1);
	 
   if( ok != 0 )
     {
      for(int i=0; i<n+1; i++)
        {
         if( buf[i] == 0 ) buf[i] = ' ';
        }
       
      s = new string(buf);
      return s.Trim();
     }
   else return s;   
  }

public bool OutIsNull(int number)
  {
   if( Handle <= 0 || number <= 0 ) return true;

   int ok = 0;
   if( Repcoder.is64() ) ok = repcoder64.rcalc_isnull_output(Handle, number);
   else ok = repcoder32.rcalc_isnull_output(Handle, number);
   
   return (ok == 1)? true: false;
  }

public string OutString(int number)
  {
   string s = "";
   if( Handle <= 0 || number <= 0 ) return s;
   
   int n = 0;
   if( Repcoder.is64() ) n = repcoder64.rcalc_get_output_string_len(Handle, number);
   else n = repcoder32.rcalc_get_output_string_len(Handle, number);
   
   if( n <= 0 ) return s;
   
   char[] buf = new char[n+1];
     
   int ok = 0;
   if( Repcoder.is64() ) ok = repcoder64.rcalc_copy_output_string(Handle, number, buf, n+1);
   else ok = repcoder32.rcalc_copy_output_string(Handle, number, buf, n+1);
	 
   if( ok != 0 )
     {
      for(int i=0; i<n+1; i++)
        {
         if( buf[i] == 0 ) buf[i] = ' ';
        }
       
      s = new string(buf);
      return s.Trim();
     }
   else return s;
  }

public double OutDouble(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;

   if( Repcoder.is64() ) return repcoder64.rcalc_get_output_double(Handle, number);
   else return repcoder32.rcalc_get_output_double(Handle, number);
  }

public int OutInt(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;

   if( Repcoder.is64() ) return repcoder64.rcalc_get_output_int(Handle, number);
   else return repcoder32.rcalc_get_output_int(Handle, number);
  }

public long OutNumeric(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;

   if( Repcoder.is64() ) return repcoder64.rcalc_get_output_numeric(Handle, number);
   else return repcoder32.rcalc_get_output_numeric(Handle, number);
  }

public long OutTime(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;

   if( Repcoder.is64() ) return repcoder64.rcalc_get_output_time(Handle, number);
   else return repcoder32.rcalc_get_output_time(Handle, number);
  }

public static int Year(long value) { return Repcoder.is64()? repcoder64.rcalc_get_year(value): repcoder32.rcalc_get_year(value); }
public static int Month(long value) { return Repcoder.is64()? repcoder64.rcalc_get_month(value): repcoder32.rcalc_get_month(value); }
public static int Day(long value) { return Repcoder.is64()? repcoder64.rcalc_get_day(value): repcoder32.rcalc_get_day(value); }
public static int Hour(long value) { return Repcoder.is64()? repcoder64.rcalc_get_hour(value): repcoder32.rcalc_get_hour(value); }
public static int Minute(long value) { return Repcoder.is64()? repcoder64.rcalc_get_minute(value): repcoder32.rcalc_get_minute(value); }
public static int Second(long value) { return Repcoder.is64()? repcoder64.rcalc_get_second(value): repcoder32.rcalc_get_second(value); }
public static int Millisec(long value) { return Repcoder.is64()? repcoder64.rcalc_get_millisec(value): repcoder32.rcalc_get_millisec(value); }

public static bool LastError()
  {
   int n = 0;
   if( Repcoder.is64() ) n = repcoder64.rcalc_get_error_text_len();
   else n = repcoder32.rcalc_get_error_text_len();
   
   return (n>0) ? true: false;
  }
  
public static void ShowError(IntPtr hParent)
  {
   if( Repcoder.is64() ) repcoder64.rcalc_show_error(hParent);
   else repcoder32.rcalc_show_error(hParent);
  }
  
public static string ErrorString()
  {
   int n = 0;
   if( Repcoder.is64() ) n = repcoder64.rcalc_get_error_text_len();
   else n = repcoder32.rcalc_get_error_text_len();

   string s = "";
   if( n <= 0 ) return s;

   char[] buf = new char[n+1];
     
   int ok = 0;
   if( Repcoder.is64() ) ok = repcoder64.rcalc_copy_error_text(buf, n+1);
   else ok = repcoder32.rcalc_copy_error_text(buf, n+1);
	 
   if( ok != 0 )
     {
      for(int i=0; i<n+1; i++)
        {
         if( buf[i] == 0 ) buf[i] = ' ';
        }
       
      s = new string(buf);
      return s.Trim();
     }
   else return s;
  }
}
