
//compile: csc test_admin_cs.cs repcoder.cs

using System;

class App
{
 public static void Main()
   {
    if( !Repcoder.init() ) 
      {
       Console.WriteLine("Repcoder.init() error ...");
       return;
      }

    bool ok = Repcoder.admin_setup(false, /* bInterbase: 0 - Firebird, 1 - InterBase */
    "repcadmin_demo.fdb", /* ConnString - reporting database */
    "REPC_ADMIN", /* User - reporting database */
    "admin", /* Password - reporting database */
    "Demo", /* ProjectName - reporting database */
    "REPCoder Test", /* DbName - target database */
    "", /* DbLogin (optional) - target database */
    "admin", /* DbPassword - target database */
    "", /* DbRole (optional) - target database */
    true, /* bVerify (0 - no verification, 1 - verify if ProjectName and DbName exist and if User has access to DbName)*/
    true /* bShowErrorMess (0, 1) */
    );
      
    if( !ok ) 
      { 
       Repcoder.exit();
       Console.WriteLine("Repcoder.admin_setup() error ..."); 
       return; 
      }      
    
    Repcoder.call_report((IntPtr)0 /*hParent*/, true /*bModal*/, "Report_24 - long memo" /* ReportName: do not specify .sfm extension */, false /*bDesignMode*/);
    
    Repcoder.call_report((IntPtr)0, true, "Report_25 - statistics", false);
    
    string s = Repcoder.get_report_desc("Report_25 - statistics"); /* ReportName: do not specify .sfm extension */
    Console.WriteLine("Report_25 description: " + s);
        
    Repcoder.exit();
   }
}
