
//compile: dcc32 -CC test_admin_delphi.pas repcoder.pas

program test_delphi;

uses sysutils, repcoder;

var 
ok: Boolean;
buf: Array[0..2048] of WideChar;

begin

if repc_init = False then 
begin 
  WriteLn('repc_init() error ...'); 
  Halt(1); 
end;

ok := repc_admin_setup(False, (* bInterbase: 0 - Firebird, 1 - InterBase *)
'repcadmin_demo.fdb', (* ConnString - reporting database *)
'REPC_ADMIN', (* User - reporting database *)
'admin', (* Password - reporting database *)
'Demo', (* ProjectName - reporting database *)
'REPCoder Test', (* DbName - target database *)
'', (* DbLogin (optional) - target database *)
'admin', (* DbPassword - target database *)
'', (* DbRole (optional) - target database *)
True, (* bVerify (0 - no verification, 1 - verify if ProjectName and DbName exist and if User has access to DbName)*)
True (* bShowErrorMess (0, 1) *)
);
            
if ok = False then
begin
  repc_exit;  
  WriteLn('repc_admin_setup() error ...'); 
  Halt(1); 
end;
        
repc_call_report(0 (*hParent*), True (*bModal*), 'Report_24 - long memo' (* ReportName: do not specify .sfm extension *), False (*bDesignMode*));
    
repc_call_report(0, True, 'Report_25 - statistics', False);
      
repc_get_report_desc('Report_25 - statistics', buf, 2048); (* ReportName: do not specify .sfm extension *)
Write('Report_25 description: ' + buf);

repc_exit;
end.
